﻿#include "define.h"
#include "sort.h"
#include "resolve.h"

	uniform int	   bucketFragments;

	layout(binding = 0, r32ui) readonly uniform uimage2DArray	image_next;
	layout(binding = 1, r32ui) readonly uniform uimageBuffer	image_pointers;
	layout(binding = 4, rg32f) readonly uniform  imageBuffer	image_peel;

	uint getPixelCurrentPageID	(const ivec3 coords)				{return imageLoad (image_next	 , coords).x;}
	vec4 sharedPoolGetValue		(const uint index)					{return imageLoad (image_peel	 , int(index))  ;}
	uint sharedPoolGetLink		(const uint index)					{return imageLoad (image_pointers, int(index)).x;}

	layout(location = 0, index = 0) out vec4 out_frag_color;

	void main(void)
	{
		ivec2 coords = ivec2(gl_FragCoord.xy);

		int		counter = 0, total_counter=0;
		uint	page_id, glob_pID;

		for (int b=0; b<BUCKET_SIZE; b++)
		{
			page_id = getPixelCurrentPageID(ivec3(coords,b));
			if(page_id > 0U)
			{
				glob_pID = uint(bucketFragments*b);
				page_id += glob_pID;

				bool stay_loop = true;
				while(stay_loop)
				{
					fragments[counter++] = sharedPoolGetValue(page_id).rg;
					page_id = sharedPoolGetLink(page_id);

					if(page_id == glob_pID)
						stay_loop = false;
				}
			}
		}

		if(counter > 0)
			out_frag_color = resolve(counter, false);
		else
			discard;
	}