﻿#include "define.h"
#include "s-buffer.h"

	coherent uniform uint *next_address[COUNTERS];

	layout(binding = 1, r32ui) writeonly uniform uimage2DRect  image_next;
	layout(binding = 5, r32ui) readonly  uniform uimage2DRect  image_counter_total;

	uint addSharedNextAddress		(int j,	uint val) { return	atomicAdd	(next_address[j], val);}
	void setPixelNextAddress		(		uint val) {			imageStore	(image_next	  , ivec2(gl_FragCoord.xy), uvec4(val, 0U, 0U, 0U) );}
	uint getPixelFragCounterTotal	(				) { return	imageLoad   (image_counter_total, ivec2(gl_FragCoord.xy)).x ;}

	void main(void)
	{
		uint counter = getPixelFragCounterTotal();
		if(counter == 0U)
			discard;

		int  hash_id = hashFunction(ivec2(gl_FragCoord.xy));
		uint address = addSharedNextAddress (hash_id, counter);
		setPixelNextAddress (address);
	}