﻿#include "define.h"
#include "s-buffer.h"
#include "sort.h"
#include "resolve.h"

	uniform uint  total_fragments;
	uniform uint *final_address[COUNTERS];

	layout(binding = 0, r32ui) readonly  uniform uimage2DRect  image_counter;
	layout(binding = 1, r32ui) readonly  uniform uimage2DRect  image_next;
	layout(binding = 2, r32f ) readonly  uniform  imageBuffer  image_peel_depth;
	layout(binding = 3, r32ui) readonly  uniform uimageBuffer  image_peel_color;

	float sharedPoolGetDepthValue (const uint index) {return imageLoad (image_peel_depth, int(index)).x;}
	uint  sharedPoolGetColorValue (const uint index) {return imageLoad (image_peel_color, int(index)).x;}

	uint getPixelNextAddress  (){return imageLoad(image_next   , ivec2(gl_FragCoord.xy)).x;}
	uint getPixelFragCounter  (){return imageLoad(image_counter, ivec2(gl_FragCoord.xy)).x;}

	layout(location = 0, index = 0) out vec4 out_frag_color;

	void main(void)
	{
		int counter = int(getPixelFragCounter());
		if(counter > 0)
		{	
			uint address = getPixelNextAddress();
			int  hash_id = hashFunction(ivec2(gl_FragCoord.xy));
			uint page_id = (*final_address[hash_id]) + address;
	
			for(int i=0; i<counter; i++)
			{
				fragments[i] = vec2(i, sharedPoolGetDepthValue(page_id));
				colors	 [i] = sharedPoolGetColorValue(page_id);
				page_id		+= 1U;
			}
			out_frag_color = resolve(counter, false);
		}
		else
			discard;
	}