﻿#include "define.h"
#include "sort.h"
#include "resolve.h"

	layout(binding = 0, r32f)  readonly uniform  image2DArray	image_peel_depth;
	layout(binding = 1, r32ui) readonly uniform uimage2DArray	image_peel_color;
	layout(binding = 2, r32ui) readonly uniform uimage2DRect	image_counter;

	uint  getPixelFragCounter		(				  ) {return	imageLoad (image_counter   , ivec2(gl_FragCoord.xy)).r;}
	float getPixelFragDepthValue	(const int coord_z) {return imageLoad (image_peel_depth, ivec3(gl_FragCoord.xy, coord_z)).r;}
	uint  getPixelFragColorValue	(const int coord_z) {return imageLoad (image_peel_color, ivec3(gl_FragCoord.xy, coord_z)).r;}

	layout(location = 0, index = 0) out  vec4 out_frag_color;

	void main(void)
	{
		int counter = int(getPixelFragCounter());
		if(counter > 0)
		{
			if (counter > HEAP_SIZE)
			{
				vec2 maxFR = vec2(-1.0f,0.0f);
				for(int i=0; i<HEAP_SIZE_1n; i++)
				{
					fragments[i] = vec2(i, getPixelFragDepthValue(i));
					if(maxFR.g < fragments[i].g)
					{
						maxFR.r = i;
						maxFR.g = fragments[i].g;
					}
				}
				
				vec2 newFR = vec2(HEAP_SIZE_1n, getPixelFragDepthValue(HEAP_SIZE_1n));
				if(newFR.g < maxFR.g)
				{
					fragments[HEAP_SIZE_1n] = maxFR;
					fragments[int(maxFR.r)] = newFR;
				}
				else
					fragments[HEAP_SIZE_1n] = newFR;

				for(int i=HEAP_SIZE; i<counter; i++)
				{
					newFR = vec2(i, getPixelFragDepthValue(i));
					if(newFR.g < fragments[HEAP_SIZE_1n].g)
					{
						maxFR = getMaxFromLocalArray2();
						if(newFR.g < maxFR.g)
						{
							fragments[HEAP_SIZE_1n] = maxFR;
							fragments[int(maxFR.r)] = newFR;
						}
						else
							fragments[HEAP_SIZE_1n] = newFR;
					}
				}
				
				for(int i=0; i<HEAP_SIZE; i++)
				{
					colors	 [i]   = getPixelFragColorValue	(int(fragments[i].r));
					fragments[i].r = i;
				}
				counter = HEAP_SIZE;
			}
			else
			{
				for(int i=0; i<counter; i++)
				{
					fragments[i] = vec2(i, getPixelFragDepthValue(i));
					colors	 [i] = getPixelFragColorValue	(i);
				}
			}
			
			out_frag_color = resolve(counter, false);
		}
		else
			discard;
	}