﻿#include "define.h"

	vec4 computePixelColor();
	
	uniform uint total_fragments;
	
	layout(binding = 0, r32ui) coherent uniform uimage2DRect  image_next;
	layout(binding = 1, r32ui) writeonly uniform uimageBuffer image_pointers;
	layout(binding = 2, r32f ) writeonly uniform  imageBuffer image_peel_depth;
	layout(binding = 3, r32ui) writeonly uniform uimageBuffer image_peel_color;
	layout(binding = 4, offset = 0)		 uniform atomic_uint  next_address;

	uint exchangePixelCurrentPageID	(					const uint  val)	{ return imageAtomicExchange(image_next, ivec2(gl_FragCoord.xy), val);}
	void sharedPoolSetDepthValue	(const uint index,	const float val)	{		 imageStore(image_peel_depth, int(index),  vec4(val, 0.0f, 0.0f, 0.0f));}
	void sharedPoolSetColorValue	(const uint index,	const uint  val)	{		 imageStore(image_peel_color, int(index), uvec4(val, 0U  , 0U  , 0U  ));}
	void sharedPoolSetLink			(const uint index,	const uint  val)	{		 imageStore(image_pointers	, int(index), uvec4(val, 0U  , 0U  , 0U  ));}

void main(void)
{
	uint page_id = atomicCounterIncrement(next_address);

	if(page_id < total_fragments)
	{
		sharedPoolSetLink		(page_id, exchangePixelCurrentPageID(page_id));	
		sharedPoolSetDepthValue (page_id, gl_FragCoord.z);
		sharedPoolSetColorValue (page_id, packUnorm4x8(computePixelColor()));

		discard;
	}
}