﻿#include "define.h"
#include "sort.h"
#include "resolve.h"

	layout(binding = 0, r32ui) readonly uniform uimage2DRect image_next;
	layout(binding = 1, r32ui) readonly uniform uimageBuffer image_pointers;
	layout(binding = 2, r32f ) readonly uniform  imageBuffer image_peel_depth;
	layout(binding = 3, r32ui) readonly uniform uimageBuffer image_peel_color;

	uint getPixelCurrentPageID	 (				  )  {return imageLoad (image_next		, ivec2(gl_FragCoord.xy)).r;}
	float sharedPoolGetDepthValue(const uint index)	 {return imageLoad (image_peel_depth, int(index)).r;}
	uint  sharedPoolGetColorValue(const uint index)	 {return imageLoad (image_peel_color, int(index)).r;}
	uint  sharedPoolGetLink		 (const uint index)	 {return imageLoad (image_pointers  , int(index)).r;}
	
	layout(location = 0, index = 0) out vec4 out_frag_color;

	void main(void)
	{
		uint page_id = getPixelCurrentPageID();
		if(page_id > 0U)
		{
			vec3 maxFR = vec3(-1.0f,0.0f,0.0f);

			int		counter = 0;
			bool	stay_loop = true;
			while(stay_loop)
			{
				if (counter < HEAP_SIZE_1n)
				{
					fragments[counter] = vec2(page_id, sharedPoolGetDepthValue(page_id));
					if(maxFR.g < fragments[counter].g)
					{
						maxFR.r = counter;
						maxFR.g = fragments[counter].g;
						maxFR.b = fragments[counter].r;
					}
				}
				else if (counter == HEAP_SIZE_1n)
				{
					vec2 newFR = vec2(page_id, sharedPoolGetDepthValue(page_id));
					if(newFR.g < maxFR.g)
					{
						fragments[HEAP_SIZE_1n] = maxFR.bg;
						fragments[int(maxFR.r)] = newFR;
					}
					else
						fragments[HEAP_SIZE_1n] = newFR;
				}
				else
				{
					vec2 newFR = vec2(page_id, sharedPoolGetDepthValue(page_id));
					if(newFR.g < fragments[HEAP_SIZE_1n].g)
					{
						maxFR = getMaxFromLocalArray3();
						if(newFR.g < maxFR.g)
						{
							fragments[HEAP_SIZE_1n] = maxFR.bg;
							fragments[int(maxFR.r)] = newFR;
						}
						else
							fragments[HEAP_SIZE_1n] = newFR;
					}
				}

				counter++;
				page_id	= sharedPoolGetLink(page_id);
				if(page_id == 0U)
					stay_loop = false;
			}

			if(counter > HEAP_SIZE)
				counter = HEAP_SIZE;
			for(int i=0; i<counter; i++)
			{
				colors	 [i]   = sharedPoolGetColorValue (uint(fragments[i].r));
				fragments[i].r = i;
			}

			out_frag_color = resolve(counter, false);
		}
		else
			discard;
	}