﻿#include "define.h"

	uniform int width_2; // 2*screen_width

	layout(binding = 1, r32ui) writeonly uniform uimageBuffer image_pointers;
	layout(binding = 2, r32f ) writeonly uniform  imageBuffer image_peel_depth;
	layout(binding = 3, r32ui) writeonly uniform uimageBuffer image_peel_color;

	void sharedPoolSetDepthValue(const uint index,	const float val) { imageStore (image_peel_depth, int(index),  vec4(val, 0.0f, 0.0f, 0.0f));}
	void sharedPoolSetColorValue(const uint index,	const uint  val) { imageStore (image_peel_color, int(index), uvec4(val,   0U,   0U,   0U));}
	void sharedPoolSetLink		(const uint index,	const uint  val) { imageStore (image_pointers  , int(index), uvec4(val,   0U,   0U,   0U));}
	
	void main(void)
	{
		uint  P_ID, ID = uint(gl_FragCoord.x + width_2*gl_FragCoord.y) * 2U + 1U;

		// Tail node
		{
			P_ID = ID ;

			sharedPoolSetLink		(P_ID,   0U);
			sharedPoolSetDepthValue (P_ID, 1.0f);
			sharedPoolSetColorValue (P_ID,   0U);
		}

		// Head node
		{
			P_ID = ID+1U;

			sharedPoolSetLink		(P_ID,   ID);
			sharedPoolSetDepthValue (P_ID, 0.0f);
			sharedPoolSetColorValue (P_ID,   0U);
		}
	}
