﻿#include "define.h"
#include "sort.h"
#include "resolve.h"

// IN
	uniform int width_2; // 2*screen_width
	
	layout(binding = 1, r32ui) readonly uniform uimageBuffer image_pointers;
	layout(binding = 2, r32f ) readonly uniform  imageBuffer image_peel_depth;
	layout(binding = 3, r32ui) readonly uniform uimageBuffer image_peel_color;

	uint  sharedPoolGetLink		 (const uint index)	{return imageLoad (image_pointers  , int(index)).r;}
	float sharedPoolGetDepthValue(const uint index)	{return imageLoad (image_peel_depth, int(index)).r;}
	uint  sharedPoolGetColorValue(const uint index)	{return imageLoad (image_peel_color, int(index)).r;}
	
// OUT
	layout(location = 0, index = 0) out vec4 out_frag_color;

	void main(void)
	{	
		uint currID = uint(gl_FragCoord.x + width_2*gl_FragCoord.y) * 2U + 2U;	// head pointer
		currID		= sharedPoolGetLink(currID);								// start from fr[1]

		int counter = 0;
		for(int i=0; i<HEAP_SIZE; i++)
		{
			if(currID == 0U)
				break;

			counter++;
			fragments[i] = vec2(i,sharedPoolGetDepthValue(currID).r);
			colors[i]	 = sharedPoolGetColorValue(currID);

			currID = sharedPoolGetLink(currID);
		}
		if(counter < HEAP_SIZE)
			counter--;

		if(counter > 0)
			out_frag_color = resolve(counter, true);
		else
			discard;
	}