﻿#include "define.h"

	uniform float zNear;
	uniform float zFar;

	layout(binding = 0, r32ui) coherent uniform uimage2DArray	 image_peel_depth;

	uint getMaxPixelFragDepthValue	(									) { return imageLoad     (image_peel_depth, ivec3(gl_FragCoord.xy, HEAP_SIZE_1n)).r;}
	uint getMinPixelFragDepthValue	(const int coord_z, const uint val	) { return imageAtomicMin(image_peel_depth, ivec3(gl_FragCoord.xy, coord_z), val);}

	uint packDepthTo32bitUint		(float z							) {return uint( ((z-zNear)/zFar) * float(Packed_1f) );}

	void main(void)
	{
		uint Curr_Z, Packed_Z = packDepthTo32bitUint(gl_FragCoord.z);
		if(Packed_Z < getMaxPixelFragDepthValue())
			for(int i=0; i<HEAP_SIZE; i++)
			{
				Curr_Z = getMinPixelFragDepthValue(i, Packed_Z);
			
				if( Curr_Z > Packed_Z)
					Packed_Z = Curr_Z;
				else if(Curr_Z >= Packed_1f) 
					break;
			}
		discard;
	}