﻿#include "define.h"

	vec4 computePixelColor();

	uniform float zNear;
	uniform float zFar;

	layout(binding = 0, r32ui) readonly  uniform  uimage2DArray image_peel_depth;
	layout(binding = 1, r32ui) writeonly uniform  uimage2DArray image_peel_color;

	uint getPixelFragDepthValue	(const int coord_z					) {return	imageLoad (image_peel_depth, ivec3(gl_FragCoord.xy, coord_z)).r;}
	void setPixelFragColorValue	(const int coord_z, const uint val	) {			imageStore(image_peel_color, ivec3(gl_FragCoord.xy, coord_z), uvec4(val,0U,0U,0U));}
	
	uint packDepthTo32bitUint	(float z							) { return uint( ((z-zNear)/zFar) * float(Packed_1f) );}

	void main(void)
	{
		uint Zi, Packed_Z = packDepthTo32bitUint(gl_FragCoord.z);
		
		if(Packed_Z <= getMaxPixelFragDepthValue(HEAP_SIZE_1n))
			for(int i=0; i<HEAP_SIZE; i++)
			{
				Zi = getPixelFragDepthValue(i);
				if (Zi >= Packed_1f)
					break;
				else if(Zi == Packed_Z) //else if(abs(Zi - Packed_Z) < 2)
				{
					setPixelFragColorValue(i, packUnorm4x8(computePixelColor()));
					break;
				}
			}
		discard; 
	}
