﻿#include "define.h"
#include "s-buffer.h"

	coherent uniform uint *next_address[COUNTERS];

#if atomic
	layout(binding = 0, r32ui) readonly  uniform uimage2DRect  image_counter;

	uint getPixelFragCounter  (					) { return	imageLoad   (image_counter, ivec2(gl_FragCoord.xy)).x ;}
#else
	layout(binding = 0)					 uniform sampler2DRect tex_counter;

	uint getPixelFragCounter  (					) { return	uint(texture(tex_counter  , gl_FragCoord.xy).x);}
#endif
	layout(binding = 1, r32ui) writeonly uniform uimage2DRect  image_next;

	uint addSharedNextAddress (int j,	uint val) { return	atomicAdd	(next_address[j], val);}
	void setPixelNextAddress  (			uint val) {			imageStore	(image_next	  , ivec2(gl_FragCoord.xy), uvec4(val, 0U, 0U, 0U) );}
	
	void main(void)
	{
		uint counter = getPixelFragCounter();
		if(counter == 0U)
			discard;

		int  hash_id = hashFunction(ivec2(gl_FragCoord.xy));
		uint address = addSharedNextAddress (hash_id, counter);
		setPixelNextAddress (address);
	}