﻿#include "define.h"
#include "s-buffer.h"

	uniform uint  total_fragments;
	uniform uint *final_address[COUNTERS];

	vec4 computePixelColor();

	layout(binding = 1, r32ui) coherent  uniform uimage2DRect image_next;
	layout(binding = 2, r32f ) writeonly uniform  imageBuffer image_peel_depth;
	layout(binding = 3, r32ui) writeonly uniform uimageBuffer image_peel_color;
	
	uint addPixelNextAddress	 (					  const uint  val)	{return imageAtomicAdd	(image_next, ivec2(gl_FragCoord.xy), val);}
	void sharedPoolSetDepthValue (const uint index  , const  vec4 val)	{imageStore	(image_peel_depth, int(index), val);}
	void sharedPoolSetColorValue (const uint index  , const uvec4 val)	{imageStore	(image_peel_color, int(index), val);}

	void main(void)
	{
		float Z = gl_FragCoord.z;
		uint  C = packUnorm4x8(computePixelColor());
	
		uint  page_id = addPixelNextAddress(1U);
		int   hash_id = hashFunction(ivec2(gl_FragCoord.xy));
		uint  sum     = (*final_address[hash_id]) + page_id;

	#if inverse
		uint  index = hash_id < COUNTERS_2d ? sum : total_fragments - sum;
	#else
		uint  index = sum;
	#endif

		sharedPoolSetDepthValue (index,  vec4(Z,0.0f,0.0f,0.0f));
		sharedPoolSetColorValue (index, uvec4(C,  0U,  0U,  0U));
	}