﻿#include "define.h"
#include "s-buffer.h"
#include "sort.h"
#include "resolve.h"

	uniform uint  total_fragments;
	uniform uint *final_address[COUNTERS];
#if atomic
	layout(binding = 0, r32ui) readonly  uniform uimage2DRect  image_counter;

	uint getPixelFragCounter  (){return imageLoad(image_counter, ivec2(gl_FragCoord.xy)).x;   }
#else
	layout(binding = 0)					 uniform sampler2DRect tex_counter;

	uint getPixelFragCounter  (){return uint(texture(tex_counter, ivec2(gl_FragCoord.xy)).x); }
#endif
	layout(binding = 1, r32ui) readonly  uniform uimage2DRect  image_next;
	layout(binding = 2, r32f ) readonly  uniform  imageBuffer  image_peel_depth;
	layout(binding = 3, r32ui) readonly  uniform uimageBuffer  image_peel_color;

	float getPixelFragDepthValue (const uint index) {return imageLoad (image_peel_depth, int(index)).x;}
	uint  getPixelFragColorValue (const uint index) {return imageLoad (image_peel_color, int(index)).x;}
	uint  getPixelNextAddress	 (				  ) {return imageLoad(image_next   , ivec2(gl_FragCoord.xy)).x-1U;}

	layout(location = 0, index = 0) out vec4 out_frag_color;

	void main(void)
	{
		int counter = int(getPixelFragCounter());
		if(counter > 0)
		{	
			uint address = getPixelNextAddress();
			int  hash_id = hashFunction(ivec2(gl_FragCoord.xy));
#if inverse	
			bool front_prefix = hash_id < COUNTERS_2d ? true : false;
#else
			bool front_prefix = true;
#endif
			uint sum = (*final_address[hash_id]);

			uint page_id   = front_prefix ? address + sum : total_fragments - address - sum;
			uint direction = front_prefix ? -1U : 1U;

			for(int i=0; i<counter; i++)
			{
				fragments[i] = vec2(i, getPixelFragDepthValue(page_id));
				colors	 [i] = getPixelFragColorValue(page_id);
				page_id		+= direction;
			}

			out_frag_color = resolve(counter, false);
		}
		else
			discard;
	}